/*
 * $Header: /home/puhuri/Tutkimus/src/timer/RCS/sched_tst.h,v 1.6 1997/05/14 12:50:28 puhuri Exp puhuri $
 *
 * $Log: sched_tst.h,v $
 * Revision 1.6  1997/05/14 12:50:28  puhuri
 * Toisten mittausten versio.
 *
 * Revision 1.5  1997/02/27 13:23:57  puhuri
 * Muutettu mittaus aikapohjaiseksi, vaaditut muutokset.
 * Parametri- ja logiikkavirheet eroiteltu.
 *
 * Revision 1.4  1997/02/19 12:47:26  puhuri
 * Ekojen mittausten versio
 *
 * Revision 1.3  1996/11/27 13:07:11  puhuri
 * Ehk toimiva versio.
 *
 * Revision 1.2  1996/11/22 08:28:18  puhuri
 * Conf-rakenne.  Uutta rakennetta vastaava.
 *
 * Revision 1.1  1996/11/14 10:33:23  puhuri
 * Initial revision
 *
 *
 *
 */

#include <sys/time.h>
#ifdef sun
#include <errno.h>
#endif
#define i10E6	1000000		/* miljoona */
#define BUF_SIZE 1<<10		/* ison puskurin koko */
#define SBUF_SIZE 1<<4		/* pienen puskurin koko */
#define IN_QUEUE 5		/* montako yhteytt sallitaan jonoon */
#define ENTRY_PER_LOOP 3	/* montako lokikirjoitusta / kierros */
#define STORE_LOG(OFF,BYT) \
    if (gettimeofday (&(log[ENTRY_PER_LOOP * i + OFF].timeval), NULL) < 0) {\
      perror ("gettimeofday: ");\
      exit(1);\
    }\
    log[ENTRY_PER_LOOP * i + OFF].read_bytes = BYT;
#define TDIFF(X,Y) ((((X).tv_sec - (Y).tv_sec) * i10E6) + ((X).tv_usec - (Y).tv_usec))
#define ID_CHAR_EMPTY 't'
#define ID_CHAR_SEND 's'
#define ID_CHAR_RECV 'r'
#define REMOTE_SHELL "ssh"
#define UDP_COUNT 10		/* synkronointipakettien mr */
#define UDP_SELECT_TIMEOUT_SEC 1 /* 1 s */
#define UDP_SELECT_TIMEOUT_USEC 0 /* 0 us */
#define ENDIAN_MAGIC_NUMBER 0x01020304 /* luku, josta tunnetaan */
#define PORT_SIZE 5
#define STROF2(X) #X
#define STROF(X) STROF2(X)
#define PERROR(STR, ERR) PERROR2(STR, ERR, __LINE__)
#define PERROR2(STR, ERR, LINE) do { \
  perror (__FILE__ ":"  STROF2(LINE) ":" STR); \
  if (!((ERR) & ERR_NOEXIT)) exit ((ERR)); } while(0)

#ifdef DEBUG_PRINTING
#define DPRINTF(format, args...) \
 fprintf (stderr, "%s:%d: " format "\n", __FILE__, __LINE__, ## args); }
#else
#define DPRINTF(format, args...)
#endif

/*
 * Virhepaluukoodit
 */
#define  ERR_NOEXIT 0x80000000
enum {
  OK = 0,
  ERR_BAD_USAGE,
  ERR_BAD_PARAMETER,
  ERR_BAD_DIRECTORY,
  ERR_FILEOPEN,
  ERR_FILECLOSE,
  ERR_FILEWRITE,
  ERR_PIPEOPEN,
  ERR_PIPEREAD,
  ERR_FORK_FAILED,
  ERR_SETPGID,
  ERR_EXEC,
  ERR_NO_MEMORY,
  ERR_GETTIMEOFDAY,
  ERR_SOCKET,
  ERR_BIND,
  ERR_LISTEN,
  ERR_SELECT,
  ERR_RECVFROM,
  ERR_SENDTO,
  ERR_READ,
  ERR_WRITE,
  ERR_BAD_ENDIAN,
  ERR_WAIT,
  ERR_GETHOSTBYNAME,
  ERR_GETSOCKNAME,
  ERR_CONNECT,
  ERR_ACCEPT,
  ERR_LSEEK,
  ERR_KILL,
  ERR_LOGIC			/* logical error */
};

struct log_entry {
  struct timeval timeval;
  int read_bytes;
};

struct time_message {
  int number;
  struct timeval time;
};

struct conf_info {
  long tom;			/* T: mittauksen aika */
  int tprogs;			/* n: tyhjnpyrijien mr */
  int tloops;			/* l: tyhjnpyrijien kierrokset */
  long data_size;		/* d: tyhjnpyrijien datakoko */
  int usleep_start;		/* s: kauanko odotetaan ennen tallennusta */
  char *usleep_start_str;	/* s: kauanko odotetaan ennen tallennusta */
  int usleep_end;		/* z: kauanko odotetaan ennen tulostusta */
  char *usleep_end_str;		/* z: kauanko odotetaan ennen tulostusta */
  char *ofile_fmt;		/* o: tulostustiedoston muoto */
  char *host;			/* h: etkone */
  char *current_dir;		/* c: hakemisto etkoneessa */
  int read_size;		/* r: lukukoko (verkosta) */
  char *read_size_str;		/* r: lukukoko (verkosta) */
  int write_size;		/* w: kirjoituskoko (verkkoon) */
  int write_times;		/* t: kirjoituskerrat */
  char *write_times_str;	/* t: kirjoituskerrat */
  int wprogs;			/* m: kirjoittajien mr */
  char *in_file;		/* i: tiedosto, jota luetaan */
  int readerp;			/* R ollaako vastaanottava */
  int childs_running;		/* montako lasta on pyrimss */
  int wait_for_signal;		/* odotetaanko signaalia */
  struct timeval start_time;	/* aloitushetki */
  struct timeval go_time;	/* tallentamisen aloitushetki */
  struct timeval stop_time;	/* toiminnan lopettamisen hetki */
  int drift;			/* aikaero vastaanottavassa */
  int child_table_size;		/* taulukon koko */
  pid_t *child_table;		/* taulukko lapsiprosessien pideist */
  int port;			/* kuunteleva portti */
  int fd_to_remote;		/* kirjoitus-fd etlle */
  int fd_from_remote;		/* kirjoitus-fd etlt */
};


void printout_time_log (const struct conf_info *conf, 
			const struct log_entry *log,
			int loops, int mynro, char mytype);


void printout_time_tval (const struct conf_info *conf, 
			 const struct timeval *log,
			 int loops, int mynro, char mytype);

void *get_dirty_mem (size_t bytes);

int noworker (struct conf_info *conf);
int sender (struct conf_info *conf);
int sink (struct conf_info *conf);
void child_wait_sig (int sig);
struct time_message *sync_time_client (void);
void sync_time_server (struct conf_info *conf);
void add_child_pid (struct conf_info *conf, pid_t pid);
int decode_wait (pid_t child, int child_exit_status);
struct timeval add_time (struct timeval tv, int usec);

/*
 * Mritykset liikennesopimuksen testausta varten
 */
typedef struct cell_log {
  int min;			/* min index */
  int max;			/* max index */
  long long *table;			/* table of times */
} cell_log;

typedef struct tr_param {
  int inv_pcr;			/* peak cell rate */
  int inv_scr;			/* suistanable cell rate */
  int mbs;			/* maximum burst size */
  int mcr;			/* minimum cell rate */
  int cdvt;			/* cell delay variation tolerance */
} tr_param;

static inline int tr_eq (tr_param t1, tr_param t2) {
 return (t1.inv_pcr == t2.inv_pcr) &&
 (t1.inv_scr == t2.inv_scr) &&
 (t1.mbs == t2.mbs) &&  (t1.mcr == t2.mcr) &&
 (t1.cdvt == t2.cdvt);
}
#define TUNITS 1000000000	/* time units in 1 s */
#define TUNIT "ns"
#define BITS_PER_CELL (8*53)
#define OH_SNAP 8
#define OH_AAL5 8
#define AAL5_CELLS(X) (((X) + OH_SNAP + OH_AAL5) / 48 + 1)
int not_withn_contract (cell_log cells, tr_param tr);
